// ConsoleApplication1.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include <conio.h>
#include <stdlib.h>
#include <Windows.h>

// z̐
#define NELEMS(ary) (sizeof(ary)/sizeof(ary[0]))

// H̔z̐
#define MAZE_W    47		// 
#define MAZE_H    17		// 
#define MAZE_NUM (MAZE_W*MAZE_H)

// Hzi0: 0ȊO:ǁj
#define MAZE_TYPE_EMPTY 0
#define MAZE_TYPE_WALL  1
int maze[MAZE_NUM];

// ʃNA
void clear()
{
	system("cls");
}

// Hzݒ
void setMaze(int x, int y, int type)
{
	if (x < 0 || y < 0 || x >= MAZE_W || y >= MAZE_H)
		return;
	maze[(y*MAZE_W) + x] = type;
}
// Hz񂩂l擾
int getMaze(int x, int y)
{
	if (x < 0 || y < 0 || x >= MAZE_W || y >= MAZE_H)
		return MAZE_TYPE_WALL;
	return maze[(y*MAZE_W) + x];
}

// H
void initMaze()
{
	int i;
	// 
	for (i = 0; i < NELEMS(maze); i++)
		maze[i] = MAZE_TYPE_EMPTY;
}
// H\
void drawMaze()
{
	int x, y;

	for (y = 0; y < MAZE_H; y++)
	{
		for (x = 0; x < MAZE_W; x++)
		{
			if (getMaze(x, y) == MAZE_TYPE_EMPTY)
				_cprintf(" ");
			else
				_cprintf("*");
		}
		_cprintf("\n");
	}
}

// _|@̏zu
void _initBouMaze()
{
	int x, y;
	initMaze();
	for (y = 0; y < MAZE_H; y++)
	{
		for (x = 0; x < MAZE_W; x++)
		{
			if (x == 0 || y == 0 ||
				(x + 1) == MAZE_W || (y + 1) == MAZE_H)
			{
				// O
				setMaze(x, y, MAZE_TYPE_WALL);
			}
			else if ((x % 2) == 0 && (y % 2) == 0)
			{
				// 
				setMaze(x, y, MAZE_TYPE_WALL);
			}
		}
	}
}
// _|@ŖH
void makeBouMaze()
{
	int x, y;
	int r;
	int decision = 0;

	// 
	_initBouMaze();

	// _|Ă
	// PD̈ʒu̕ǂSɃ_œ|
	// QDłɓ|Ă_ɂ͓|Ȃ
	// RDQsڈȍ~́Aɓ|Ȃ悤ɂ

	for (y = 2; y < MAZE_H; y += 2)
	{
		for (x = 2; x < MAZE_W; x += 2)
		{
			for (;;)
			{
				// 
				decision = 0;

				// 擾
				r = rand() % 4;	// O`R
				// Qsڈȍ~͏ɓ|Ȃ
				if (y != 0 && r == 0)
					r = (rand() % 3) + 1;

				// Rӏ
				if (y != 0)
				{
					if (getMaze(x, y + 1) == MAZE_TYPE_WALL &&
						getMaze(x + 1, y) == MAZE_TYPE_WALL &&
						getMaze(x - 1, y) == MAZE_TYPE_WALL)
					{
						decision = 1;
						break;
					}
				}

				// _|
				switch (r)
				{
				case 0:	// 
					if (getMaze(x, y - 1) == MAZE_TYPE_EMPTY)
					{
						setMaze(x, y - 1, MAZE_TYPE_WALL);
						decision = 1;
					}
					break;
				case 1:	// E
					if (getMaze(x + 1, y) == MAZE_TYPE_EMPTY)
					{
						setMaze(x + 1, y, MAZE_TYPE_WALL);
						decision = 1;
					}
					break;
				case 2:	// 
					if (getMaze(x, y + 1) == MAZE_TYPE_EMPTY)
					{
						setMaze(x, y + 1, MAZE_TYPE_WALL);
						decision = 1;
					}
					break;
				case 3:	// 
					if (getMaze(x - 1, y) == MAZE_TYPE_EMPTY)
					{
						setMaze(x - 1, y, MAZE_TYPE_WALL);
						decision = 1;
					}
					break;
				}

				if (decision)
					break;
			}
		}
	}
}

// C֐
int main()
{
	// ̃V[hύX
	srand(GetTickCount());
	// H
	initMaze();
	// ʃNA
	clear();
	// _|@ŖH
	makeBouMaze();
	// H`
	drawMaze();

	return 0;
}

